// VideoUpdate.cpp: implementation of the CVideoUpdate class.
//
//////////////////////////////////////////////////////////////////////

#ifndef USING_ENGINUITY
#define USING_ENGINUITY
#endif
#include "engine.h"
#include "VideoUpdate.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int CVideoUpdate::scrWidth=800;
int CVideoUpdate::scrHeight=600;
int CVideoUpdate::scrBPP=16;

CVideoUpdate::CVideoUpdate()
{

}

CVideoUpdate::~CVideoUpdate()
{

}

bool CVideoUpdate::Start()
{
	screenWidth=new Dator<int>(scrWidth); 
	CSettingsManager::GetSingleton().RegisterVariable("screenX",CMMPointer<BaseDator>(screenWidth));
	screenHeight=new Dator<int>(scrHeight); 
	CSettingsManager::GetSingleton().RegisterVariable("screenY",CMMPointer<BaseDator>(screenHeight));
	screenBPP=new Dator<int>(scrBPP); 
	CSettingsManager::GetSingleton().RegisterVariable("screenBPP",CMMPointer<BaseDator>(screenBPP));

	if(-1==SDL_InitSubSystem(SDL_INIT_VIDEO))
	{
		CLog::Get().Write(LOG_CLIENT,IDS_GENERIC_SUB_INIT_FAIL,"Video",SDL_GetError());
		return false;
	}
	SDL_GL_SetAttribute( SDL_GL_ALPHA_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 8 );
	SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

	flags = SDL_OPENGL | SDL_ANYFORMAT | SDL_FULLSCREEN;

	if(!SDL_SetVideoMode(scrWidth, scrHeight, scrBPP, flags))
	{
		CLog::Get().Write(LOG_CLIENT, IDS_BAD_DISPLAYMODE, scrWidth, scrHeight, scrBPP, SDL_GetError());
		return false;
	}

	//hide the mouse cursor
	SDL_ShowCursor(SDL_DISABLE);

	//create graphics-based singletons
	CTextureManager::Create();

	return true;
}

void CVideoUpdate::Update()
{
	SDL_GL_SwapBuffers();
}

void CVideoUpdate::Stop()
{
	CTextureManager::Destroy();

	SDL_QuitSubSystem(SDL_INIT_VIDEO);

	CSettingsManager::GetSingleton().UnregisterVariable("screenX");
	CSettingsManager::GetSingleton().UnregisterVariable("screenY");
	CSettingsManager::GetSingleton().UnregisterVariable("screenBPP");
}

CMMDynamicBlob<frect> *CVideoUpdate::GetVideoModesList()
{
	SDL_Rect **modes=SDL_ListModes(NULL, flags);
	if(!modes)return 0;
	if(modes==(SDL_Rect**)-1)return 0;
	//find out how many modes are in the list
	for(int i=0;modes[i];i++)
		;
	CMMDynamicBlob<frect> *blob=new CMMDynamicBlob<frect>(i);
	for(i=0;modes[i];i++)
	{
		(*blob)[i].x2=modes[i]->w;
		(*blob)[i].y2=modes[i]->h;
	}
	return blob;
}