#ifndef ENGINE_H_INCLUDED
#define ENGINE_H_INCLUDED

#pragma warning ( disable : 4786 )


#include <iostream>
#include <ostream>
#include <istream>
#include <fstream>
#include <list>
#include <string>
#include <map>
#include <deque>
#include <vector>
#include <stack>
#include <algorithm>
#include <functional>
#include <cassert>
#include <sstream>
#include <cmath>
#include <ctime>

#ifdef WIN32
#include <windows.h>
#endif

//even though resource.h is technically a Win32-resource file, it's just a bunch of defines, so it's ok (and necessary)
#include "resource.h"

#include <sdl.h>
#include <SDL_thread.h>
#include <sdl_net.h>
#include <sdl_image.h>
#include <sdl_ttf.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <fmod.h>

#include <sys/types.h>
#include <sys/stat.h>

namespace Enginuity
{

//foundation layer headers
#include "log.h"
#include "mmanager.h"
#include "singleton.h"
#include "functor.h"
#include "thread.h"
#include "dator.h"
#include "kernel.h"
#include "settings.h"
#include "profiler.h"
#include "profileloghandler.h"


//task pool
#include "videoupdate.h"
#include "globalTimer.h"
#include "inputtask.h"
#include "soundtask.h"

//misc
#include "misc.h"
#include "math.h"
#include "interpolators.h"
#include "triggers.h"

#include "serialize.h"

}

#ifdef USING_ENGINUITY
using namespace Enginuity;
#endif

extern const std::string buildStamp;

#endif